git-mergetool--lib.sh 7.59 KB
Newer Older
1
#!/bin/sh
2
# git-mergetool--lib is a library for common merge tool functions
3 4
MERGE_TOOLS_DIR=$(git --exec-path)/mergetools

5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21
mode_ok () {
	if diff_mode
	then
		can_diff
	elif merge_mode
	then
		can_merge
	else
		false
	fi
}

is_available () {
	merge_tool_path=$(translate_merge_tool_path "$1") &&
	type "$merge_tool_path" >/dev/null 2>&1
}

22 23 24 25 26 27 28 29 30 31 32 33 34 35
list_config_tools () {
	section=$1
	line_prefix=${2:-}

	git config --get-regexp $section'\..*\.cmd' |
	while read -r key value
	do
		toolname=${key#$section.}
		toolname=${toolname%.cmd}

		printf "%s%s\n" "$line_prefix" "$toolname"
	done
}

36 37 38
show_tool_names () {
	condition=${1:-true} per_line_prefix=${2:-} preamble=${3:-}
	not_found_msg=${4:-}
39
	extra_content=${5:-}
40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57

	shown_any=
	( cd "$MERGE_TOOLS_DIR" && ls ) | {
		while read toolname
		do
			if setup_tool "$toolname" 2>/dev/null &&
				(eval "$condition" "$toolname")
			then
				if test -n "$preamble"
				then
					printf "%s\n" "$preamble"
					preamble=
				fi
				shown_any=yes
				printf "%s%s\n" "$per_line_prefix" "$toolname"
			fi
		done

58 59 60 61 62 63 64 65 66 67 68 69 70
		if test -n "$extra_content"
		then
			if test -n "$preamble"
			then
				# Note: no '\n' here since we don't want a
				# blank line if there is no initial content.
				printf "%s" "$preamble"
				preamble=
			fi
			shown_any=yes
			printf "\n%s\n" "$extra_content"
		fi

71 72 73 74 75 76 77 78 79
		if test -n "$preamble" && test -n "$not_found_msg"
		then
			printf "%s\n" "$not_found_msg"
		fi

		test -n "$shown_any"
	}
}

80 81 82 83 84 85 86 87 88
diff_mode() {
	test "$TOOL_MODE" = diff
}

merge_mode() {
	test "$TOOL_MODE" = merge
}

translate_merge_tool_path () {
89
	echo "$1"
90 91 92
}

check_unchanged () {
93 94
	if test "$MERGED" -nt "$BACKUP"
	then
95 96
		status=0
	else
97 98
		while true
		do
99 100
			echo "$MERGED seems unchanged."
			printf "Was the merge successful? [y/n] "
101
			read answer || return 1
102 103 104 105 106 107 108 109 110
			case "$answer" in
			y*|Y*) status=0; break ;;
			n*|N*) status=1; break ;;
			esac
		done
	fi
}

valid_tool () {
111 112 113
	setup_tool "$1" && return 0
	cmd=$(get_merge_tool_cmd "$1")
	test -n "$cmd"
114 115 116
}

setup_tool () {
117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136
	tool="$1"

	# Fallback definitions, to be overriden by tools.
	can_merge () {
		return 0
	}

	can_diff () {
		return 0
	}

	diff_cmd () {
		status=1
		return $status
	}

	merge_cmd () {
		status=1
		return $status
	}
137

138 139 140 141 142
	translate_merge_tool_path () {
		echo "$1"
	}

	if ! test -f "$MERGE_TOOLS_DIR/$tool"
143
	then
144 145 146 147 148
		# Use a special return code for this case since we want to
		# source "defaults" even when an explicit tool path is
		# configured since the user can use that to override the
		# default path in the scriptlet.
		return 2
149 150 151
	fi

	# Load the redefined functions
152
	. "$MERGE_TOOLS_DIR/$tool"
153 154 155 156

	if merge_mode && ! can_merge
	then
		echo "error: '$tool' can not be used to resolve merges" >&2
157
		return 1
158 159 160
	elif diff_mode && ! can_diff
	then
		echo "error: '$tool' can only be used to resolve merges" >&2
161
		return 1
162 163
	fi
	return 0
164 165 166
}

get_merge_tool_cmd () {
167
	merge_tool="$1"
168 169
	if diff_mode
	then
170 171
		git config "difftool.$merge_tool.cmd" ||
		git config "mergetool.$merge_tool.cmd"
172
	else
173
		git config "mergetool.$merge_tool.cmd"
174
	fi
175 176
}

177
# Entry point for running tools
178
run_merge_tool () {
179 180 181 182 183
	# If GIT_PREFIX is empty then we cannot use it in tools
	# that expect to be able to chdir() to its value.
	GIT_PREFIX=${GIT_PREFIX:-.}
	export GIT_PREFIX

184
	merge_tool_path=$(get_merge_tool_path "$1") || exit
185 186 187
	base_present="$2"
	status=0

188 189
	# Bring tool-specific functions into scope
	setup_tool "$1"
190 191 192 193 194 195 196 197 198 199 200 201 202
	exitcode=$?
	case $exitcode in
	0)
		:
		;;
	2)
		# The configured tool is not a built-in tool.
		test -n "$merge_tool_path" || return 1
		;;
	*)
		return $exitcode
		;;
	esac
203 204 205

	if merge_mode
	then
206
		run_merge_cmd "$1"
207
	else
208
		run_diff_cmd "$1"
209
	fi
210 211 212
	return $status
}

213 214
# Run a either a configured or built-in diff tool
run_diff_cmd () {
215
	merge_tool_cmd=$(get_merge_tool_cmd "$1")
216 217 218 219 220 221 222 223 224 225 226 227
	if test -n "$merge_tool_cmd"
	then
		( eval $merge_tool_cmd )
		status=$?
		return $status
	else
		diff_cmd "$1"
	fi
}

# Run a either a configured or built-in merge tool
run_merge_cmd () {
228
	merge_tool_cmd=$(get_merge_tool_cmd "$1")
229 230
	if test -n "$merge_tool_cmd"
	then
231 232
		trust_exit_code=$(git config --bool \
			"mergetool.$1.trustExitCode" || echo false)
233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248
		if test "$trust_exit_code" = "false"
		then
			touch "$BACKUP"
			( eval $merge_tool_cmd )
			status=$?
			check_unchanged
		else
			( eval $merge_tool_cmd )
			status=$?
		fi
		return $status
	else
		merge_cmd "$1"
	fi
}

249
list_merge_tool_candidates () {
250 251
	if merge_mode
	then
252 253 254 255
		tools="tortoisemerge"
	else
		tools="kompare"
	fi
256 257 258 259
	if test -n "$DISPLAY"
	then
		if test -n "$GNOME_DESKTOP_SESSION_ID"
		then
260 261 262 263
			tools="meld opendiff kdiff3 tkdiff xxdiff $tools"
		else
			tools="opendiff kdiff3 tkdiff xxdiff meld $tools"
		fi
264
		tools="$tools gvimdiff diffuse ecmerge p4merge araxis bc3 codecompare"
265
	fi
266 267
	case "${VISUAL:-$EDITOR}" in
	*vim*)
268
		tools="$tools vimdiff emerge"
269 270
		;;
	*)
271
		tools="$tools emerge vimdiff"
272 273
		;;
	esac
274 275
}

276
show_tool_help () {
277
	tool_opt="'git ${TOOL_MODE}tool --tool-<tool>'"
278

279 280 281 282
	tab='	'
	LF='
'
	any_shown=no
283 284

	cmd_name=${TOOL_MODE}tool
285 286 287 288 289 290 291 292 293 294
	config_tools=$({
		diff_mode && list_config_tools difftool "$tab$tab"
		list_config_tools mergetool "$tab$tab"
	} | sort)
	extra_content=
	if test -n "$config_tools"
	then
		extra_content="${tab}user-defined:${LF}$config_tools"
	fi

295 296
	show_tool_names 'mode_ok && is_available' "$tab$tab" \
		"$tool_opt may be set to one of the following:" \
297 298
		"No suitable tool for 'git $cmd_name --tool=<tool>' found." \
		"$extra_content" &&
299 300 301 302 303 304 305
		any_shown=yes

	show_tool_names 'mode_ok && ! is_available' "$tab$tab" \
		"${LF}The following tools are valid, but not currently available:" &&
		any_shown=yes

	if test "$any_shown" = yes
306 307 308 309 310 311 312 313
	then
		echo
		echo "Some of the tools listed above only work in a windowed"
		echo "environment. If run in a terminal-only session, they will fail."
	fi
	exit 0
}

314 315
guess_merge_tool () {
	list_merge_tool_candidates
316 317 318 319 320 321 322
	cat >&2 <<-EOF

	This message is displayed because '$TOOL_MODE.tool' is not configured.
	See 'git ${TOOL_MODE}tool --tool-help' or 'git help config' for more details.
	'git ${TOOL_MODE}tool' will now attempt to use one of the following tools:
	$tools
	EOF
323 324

	# Loop over each candidate and stop when a valid merge tool is found.
325
	for tool in $tools
326
	do
327
		is_available "$tool" && echo "$tool" && return 0
328 329
	done

330
	echo >&2 "No known ${TOOL_MODE} tool is available."
331
	return 1
332 333 334 335 336
}

get_configured_merge_tool () {
	# Diff mode first tries diff.tool and falls back to merge.tool.
	# Merge mode only checks merge.tool
337 338
	if diff_mode
	then
339 340 341
		merge_tool=$(git config diff.tool || git config merge.tool)
	else
		merge_tool=$(git config merge.tool)
342
	fi
343 344
	if test -n "$merge_tool" && ! valid_tool "$merge_tool"
	then
345 346 347 348
		echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
		echo >&2 "Resetting to default..."
		return 1
	fi
349
	echo "$merge_tool"
350 351 352 353
}

get_merge_tool_path () {
	# A merge tool has been set, so verify that it's valid.
354
	merge_tool="$1"
355 356
	if ! valid_tool "$merge_tool"
	then
357 358 359
		echo >&2 "Unknown merge tool $merge_tool"
		exit 1
	fi
360 361
	if diff_mode
	then
362
		merge_tool_path=$(git config difftool."$merge_tool".path ||
363
				  git config mergetool."$merge_tool".path)
364 365
	else
		merge_tool_path=$(git config mergetool."$merge_tool".path)
366
	fi
367 368
	if test -z "$merge_tool_path"
	then
369
		merge_tool_path=$(translate_merge_tool_path "$merge_tool")
370
	fi
371
	if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
372 373
		! type "$merge_tool_path" >/dev/null 2>&1
	then
374
		echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
375
			 "'$merge_tool_path'"
376 377 378 379 380 381 382
		exit 1
	fi
	echo "$merge_tool_path"
}

get_merge_tool () {
	# Check if a merge tool has been configured
383
	merge_tool=$(get_configured_merge_tool)
384
	# Try to guess an appropriate merge tool if no tool has been set.
385 386
	if test -z "$merge_tool"
	then
387
		merge_tool=$(guess_merge_tool) || exit
388 389 390
	fi
	echo "$merge_tool"
}